﻿// NicoGinza_extendSettingPanel + SettingUtil_pr_nl
// Ginzaの設定画面を拡張 + 設定を保存するライブラリ
// 2014/02/19	ver 1.00	試しに作ってみる（NicoGinza_extendSettingPanel + SettingUtil_pr_nl）
// 2014/02/20	var 1.01	複数タブ間で設定が変更された時の処理を追加（SettingUtil_pr_nl）
// 2014/03/04	var 1.02	設定のタブにtooltipを追加する第三引数追加。なしでもOK。settingTabName_jpは短くしないと、2行になってしまうため（NicoGinza_extendSettingPanel）
// 2014/03/30	var 1.03	GINZA以外で使われた時に対応（使えないだけ） / addChangeEventListener（他のタブとの連携など）がおかしかったので修正
// 2014/03/31	var 1.04	addChangeEventListenerでチェックボックスなどの表示が変更されてなかったのを修正 / IEでの連携バグ修正
// 2015/02/04	var 1.05	仕様変更対応
/*******************************/
//使用例
//new NicoGinza_extendSettingPanel(settingTabName, settingTabName_jp)
// settingTabName:classNameとして使われる。識別用
// settingTabName_jp:設定タブでの表示用文字列として使われる。表示用
if (false) {
	if (esp) esp.remove();
	var esp = new NicoGinza_extendSettingPanel("testSetting", "テスト");
//	var esp = new NicoGinza_extendSettingPanel("testSetting", "テスト", "「テスト」にマウスを乗せると詳しい説明を表示できる");
	if (esp.IsEnabled) {
		// start_SettingUtil_pr_nl()した場合、設定は自動保存・初期値はそちらが取得される（保存済みであれば）
		esp.start_SettingUtil_pr_nl();
		// esp.addSettingElementCheckbox(settingName, defaultValue, settingName_desc, callback, selector);
		// callback: 設定が変更されたらcallback(value, settingName, element, event)が呼ばれる
		// callback, selectorは任意
		esp.addSettingElementCheckbox("enable1", true, "1 : 有効 or 無効", function(){console.log(arguments);});
		// esp.addSettingElementRadioButton(settingName, defaultValue, settingName_desc, option, option_desc, callback, selector)
		esp.addSettingElementRadioButton("option1", "C", "A or B or C", ["A", "B", "C"], ["A1", "B2", "C2"], function(){console.log(arguments);});
		// esp.addSettingElementTextbox(settingName, defaultValue, settingName_desc, size, callback, selector)
		esp.addSettingElementTextbox("text1", "123", "説明", 5, function(){console.log(arguments);})
		
		var checkbox_isDebug = esp.addSettingElementCheckbox("isDebug", false, "デバッグ", function(value){
			console.log(arguments);
		}).css("text-align", "right");
		esp.settingUtil_pr_nl.addChangeEventListener("isDebug", function(value, key, fromOtherTab){
			console.log("addChangeEventListener");
		});
			
		// 箱を作成することも可能
		esp.addElement('<div class="left"></div><div class="right"></div>');
		esp.addSettingElementCheckbox("enable2", false, "2 : 有効 or 無効", function(){console.log(arguments);}, ".right");
		
		//各メソッドの返り値は追加したdiv要素（jQuery）
	} else {
		alert(esp.errorMessage);
	}
	//表示：
	esp.show();
}
/*******************************/

if (typeof window.NicoGinza_extendSettingPanel === "undefined") {
	window.NicoGinza_extendSettingPanel = function (settingTabName, settingTabName_jp, tooltip) {
	// new NicoGinza_extendSettingPanel(settingTabName, settingTabName_jp)
	// settingTabName		:	classNameとして使われる。識別用。半角英字で始まり、半角英数一部記号のみ
	// settingTabName_jp	:	設定タブでの表示用文字列として使われる。表示用(短いほうが良い)
	// tooltip				:	設定タブにマウスを載せた時の説明(こちらを詳しく推奨)
	    var $ = this.$ = jQuery;
	    try {
	        if (settingTabName && settingTabName_jp) {
	        	this.settingTabName = settingTabName;
	        	this.settingTabName_jp = settingTabName_jp;
	        	
	        	if (window.WatchApp) {
			   //     this.playerSettingViewController = WatchApp.ns.init.PlayerInitializer.playerSettingViewController;
			        this.playerSettingViewController = require("watchapp/init/PlayerInitializer").playerSettingViewController;
			        this.playerSettingPanel = this.playerSettingViewController.$selector;
			        if (this.playerSettingPanel.find("#playerSettingPanelTab ." + settingTabName).length === 0) {
				        this.playerSettingPanel.find("#playerSettingPanelTab").append('<li class="' + settingTabName + '"><a href="javascript:;">' + settingTabName_jp + '</a></li>');
				        this.playerSettingPanel.find("#playerSettingPanelTab ." + settingTabName + " a").click($.proxy(this.playerSettingViewController.onTabClick, this.playerSettingViewController));
				        if (tooltip) this.playerSettingPanel.find("#playerSettingPanelTab ." + settingTabName + " a").attr("title", tooltip);
				        
				        this.playerSettingPanel.find("#playerSettingPanelContent").append('<li class="' + settingTabName + '"></li>');
				        this._settingPanelElement = this.playerSettingPanel.find("#playerSettingPanelContent ." + settingTabName);
				        
				        WatchApp.ns.view.player.setting.PlayerSettingViewController.ContentName[settingTabName] = settingTabName;
				        this.IsEnabled = true;
				        NicoGinza_extendSettingPanel.instances[settingTabName] = this;
				        
				        this.addElement('<div>この設定は公式ではなく、NicoCache_nl or Proxomitron のフィルタで作成されています。<br>※変更したら即座に保存されます。</div>').css("border-bottom", "2px solid gray");
				    } else {
				    	this.errorMessage = "すでに同名の設定がある";
				    }
				} else {
			    	this.errorMessage = "再生ページ(GINZA)ではない";
			    }
		    } else {
		    	this.errorMessage = "引数がおかしい";
		    }
	    } catch (e) {
	        if (window.console && typeof window.console.log !== "undefined") {
	            window.console.log("NicoGinza_extendSettingPanel：initエラー（↓）");
	            window.console.log(e);
	        }
	    }
	};
	NicoGinza_extendSettingPanel.prototype.IsEnabled = false;
	NicoGinza_extendSettingPanel.prototype.errorMessage = "";
	NicoGinza_extendSettingPanel.prototype._getElement = function(selector){
		if (typeof selector === "string") return this._settingPanelElement.find(selector);
		return this._settingPanelElement;
	};
	NicoGinza_extendSettingPanel.prototype.addElement = function(htmlElement, selector){
		var elem = this.$(htmlElement);
		this._getElement(selector).append(elem);
		return elem;
	};

	NicoGinza_extendSettingPanel.prototype.addSettingElementCheckbox = function(settingName, defaultValue, settingName_desc, callback, selector){
		var selector = this._getElement(selector);
		if (this.use_SettingUtil_pr_nl) defaultValue = this.settingUtil_pr_nl.getSetting(settingName, defaultValue);
	//	var elem = this.$('<div><label><input type="checkbox" class="' + settingName + '" ' + (defaultValue ? 'checked="checked" ' : '') + '/>' + settingName_desc + '</label></div>');
		var elem = this.$('<div><label><input type="checkbox" ' + (defaultValue ? 'checked="checked" ' : '') + '/>' + settingName_desc + '</label></div>');
		selector.append(elem);
		var _this = this;
		var originalEvent = false;
		var input = elem.find("input");
		input.change(function (event){
			var value = this.checked;
			if (_this.use_SettingUtil_pr_nl) {
				originalEvent = true;
				_this.settingUtil_pr_nl.setSetting(settingName, value);
				originalEvent = false;
			}
			if (typeof callback === "function") callback(value, settingName, this, event);
		});
		if (this.use_SettingUtil_pr_nl) {
			this.settingUtil_pr_nl.addChangeEventListener(settingName, function(value, key, fromOtherTab){
				if (!originalEvent) {
					input[0].checked = value;
					if (typeof callback === "function") callback(value, settingName, input[0], null, {fromOtherTab:fromOtherTab});
				}
				/*
				value = !!value;
				if (value !== !!input.attr("checked")) {
					input.attr("checked", value).change();
				}
				*/
			});	
		}
		return elem;
	};
	NicoGinza_extendSettingPanel.prototype.addSettingElementTextbox = function(settingName, defaultValue, settingName_desc, size, callback, selector){
		var selector = this._getElement(selector);
		if (this.use_SettingUtil_pr_nl) defaultValue = this.settingUtil_pr_nl.getSetting(settingName, defaultValue);
//		var elem = this.$('<div><input type="text" class="' + settingName + '" size="' + size + '" value="' + defaultValue + '" />' + settingName_desc + '</div>');
		var elem = this.$('<div><input type="text" size="' + size + '" value="' + defaultValue + '" />' + settingName_desc + '</div>');
		selector.append(elem);
		var _this = this;
		var originalEvent = false;
		var input = elem.find("input");
		input.change(function (event){
			var value = this.value;
			if (_this.use_SettingUtil_pr_nl) {
				originalEvent = true;
				_this.settingUtil_pr_nl.setSetting(settingName, value);
				originalEvent = false;
			}
			if (typeof callback === "function") callback(value, settingName, this, event);
		});
		if (this.use_SettingUtil_pr_nl) {
			this.settingUtil_pr_nl.addChangeEventListener(settingName, function(value, key, fromOtherTab){
				if (!originalEvent) {
					input.val(value);
					if (typeof callback === "function") callback(value, settingName, input[0], null, {fromOtherTab:fromOtherTab});
				}
			/*
				value = value || "";
				if (input.val() !== value) {
					input.val(value).change();
				}
				*/
			});	
		}
		return elem;
	};
	NicoGinza_extendSettingPanel.prototype.addSettingElementRadioButton = function(settingName, defaultValue, settingName_desc, option, option_desc, callback, selector){
//		var boxElement = this.$('<div class="' + settingName + 'Box"><div><p>' + settingName_desc + '</p></div></div>');
		var boxElement = this.$('<div><p>' + settingName_desc + '</p></div>');
		boxElement.css("padding-left", "5px");
		this.addElement(boxElement, selector);
		if (this.use_SettingUtil_pr_nl) defaultValue = this.settingUtil_pr_nl.getSetting(settingName, defaultValue);
		var _this = this;
		var originalEvent = false;
		for (var i = 0, len = option.length; i < len; i++) (function(op, op_desc){
			var elem = this.$('<div><label><input type="radio" name="' + settingName + '" value="' + op + '"' + (defaultValue === op ? 'checked="checked" ' : '') + '/>' + op_desc + '</label></div>');
			elem.css("margin-left", "20px");
			var input = elem.find("input");
			input.change(function (event){
				var value = this.value;
				if (_this.use_SettingUtil_pr_nl) {
					originalEvent = true;
					_this.settingUtil_pr_nl.setSetting(settingName, value);
					originalEvent = false;
				}
				if (typeof callback === "function") callback(value, settingName, this, event);
			});
			if (_this.use_SettingUtil_pr_nl) {
				_this.settingUtil_pr_nl.addChangeEventListener(settingName, function(value, key, fromOtherTab){
					if (!originalEvent) {
						if (op === value) {
							// まれに別タブでの変更が反映されないことがある（原因不明）
							// console.log(originalEvent, value, op, input);
							input[0].checked = true;
							if (typeof callback === "function") callback(value, settingName, input[0], null, {fromOtherTab:fromOtherTab});
						}
					}
				/*
					if (op === value && !input.attr("checked")) {
						input.attr("checked", true).change();
					}
					*/
				});	
			}
			boxElement.append(elem);
		})(option[i], option_desc[i]);
		return boxElement;
	};

	NicoGinza_extendSettingPanel.prototype.show = function(){
		WatchApp.ns.view.player.setting.PlayerSettingViewController.getInstance().show(this.settingTabName);
	};
	NicoGinza_extendSettingPanel.prototype.hide = function(){
		WatchApp.ns.view.player.setting.PlayerSettingViewController.getInstance().hide();
		// $(".panelBottom .close").click();
	};
	NicoGinza_extendSettingPanel.prototype.use_SettingUtil_pr_nl = false;
	NicoGinza_extendSettingPanel.prototype.start_SettingUtil_pr_nl = function(){
		if (this.use_SettingUtil_pr_nl) return;
		this.use_SettingUtil_pr_nl = true;
		this.settingUtil_pr_nl = SettingUtil_pr_nl.getInstance(this.settingTabName);
	};
	NicoGinza_extendSettingPanel.instances = {};
	
	NicoGinza_extendSettingPanel.prototype.remove = function(){
		this.playerSettingPanel.find("#playerSettingPanelTab ." + this.settingTabName).remove();
		this._settingPanelElement.remove();
		this.IsEnabled = false;
		if (this.use_SettingUtil_pr_nl) this.settingUtil_pr_nl.eventListenerMap = {};
		delete NicoGinza_extendSettingPanel.instances[this.settingTabName];
	};
}


/***********************************************************************************************************************************************************************************/
/***********************************************************************************************************************************************************************************/

// SettingUtil_pr_nl.js
// 設定をブラウザに保存する
/*******************************/
//使用例
if (false) {
	//var su = new SettingUtil_pr_nl("testSetting"); //他でも同じ設定を使用する可能性がある場合、↓推奨
	var su = SettingUtil_pr_nl.getInstance("testSetting");
	if (su.IsEnabled) {
		su.getSetting("settingA", "デフォルト値");
		su.getSetting("settingB", 0);
		su.getSetting("settingC", false);
		
		su.setSetting("settingA", "AAA");
		su.setSetting("settingB", 123);
		su.setSetting("settingC", true);
	}
}
/*******************************/
if (typeof window.SettingUtil_pr_nl === "undefined") {
	window.SettingUtil_pr_nl = function (key){
		this._key = key;
		this.enableLocalStorage = !!(window.localStorage && window.JSON && window.JSON.parse);
		this._data = this._getData();
		// 他のタブとの連携
		if (this.enableLocalStorage) {
			var _this = this;
			window.addEventListener("storage", function (event) {
				if (event.key === key) {
					var newData =  window.JSON.parse(event.newValue || "{}");
					// IEだけ、イベントの発生タイミングがおかしいので↑使用
					// setItem（同じタブならgetItemで新しいデータ）→同じタブでstorage event→他のタブでstorage event→他のタブのgetItemでやっとデータ取得可能
					//	var newData = _this._getData();
					// IE用対策
					if (_this.firstPageShow !== newData.SettingUtil_pr_nl_firstPageShow) {
				//		alert(window.JSON.stringify(_this._data) + "\n" + window.JSON.stringify(newData));
						_this._data_previous = _this._data;
						_this._data = newData;
						_this.dispatchEvent();
					}
				}
			});
		}
		this.eventListenerMap = {};
		this.IsEnabled = true;
		this.firstPageShow = new Date().getTime(); // IEだけ自分自身にもstorage保存イベントが発生するので対策(非同期なイベントらしいのでページを最初に開いた時刻で識別)
		SettingUtil_pr_nl.instances[key] = this;
	};
	SettingUtil_pr_nl.prototype.IsEnabled = false;
	SettingUtil_pr_nl.prototype.enableLocalStorage = false;
	SettingUtil_pr_nl.prototype.getSetting = function(key, defaultValue){
		var value = this._data[key];
		return typeof value !== "undefined" ? value : defaultValue;
	};
	SettingUtil_pr_nl.prototype.setSetting = function(key, value){
		this._data[key] = value;
		this.dispatchEvent(key);
		if (this.enableLocalStorage) this._saveData();
	};
	SettingUtil_pr_nl.prototype.resetData = function(){
		this._data = {};
		if (this.enableLocalStorage) this._saveData();
	};
	SettingUtil_pr_nl.prototype._saveData = function(){
		this._data.SettingUtil_pr_nl_firstPageShow = this.firstPageShow;
		// setItem
		window.localStorage[this._key] = window.JSON.stringify(this._data);
	};
	SettingUtil_pr_nl.prototype._getData = function(){
		// getItem
		if (this.enableLocalStorage) return window.JSON.parse(window.localStorage[this._key] || '{}');
		return {};
	};
	SettingUtil_pr_nl.prototype.addChangeEventListener = function(key, fn){
		if (!this.eventListenerMap[key]) this.eventListenerMap[key] = [];
		this.eventListenerMap[key].push(fn);
	};
	SettingUtil_pr_nl.prototype.dispatchEvent = function(key){
		var _this = this;
		function dispatch(fn_arr, value, key, fromOtherTab){
			for (var i = 0, len = fn_arr.length; i < len; i++){
				try {
					fn_arr[i](value, key, fromOtherTab);
				} catch (err){
					_this.log("addChangeEventListenerで登録した関数エラー", err);
					_this.log((i + 1) + "番目に登録した関数(key=" + key + ")", fn_arr[i]);
				}
			}
		}
		if (key) {
			if (this.eventListenerMap[key]) {
				dispatch(this.eventListenerMap[key], this._data[key], key);
			}
		} else {
			var value;
			for (key in this.eventListenerMap) {
				value = this._data[key];
				if (this._data_previous[key] !== value) dispatch(this.eventListenerMap[key], value, key, true);
			}
		}
	};
	SettingUtil_pr_nl.prototype.log = function(str, err){
		if (window.console && typeof window.console.log !== "undefined") window.console.log(["SettingUtil_pr_nl." + this._key + ".log:" + str, err]);
	};

	SettingUtil_pr_nl.getInstance  = function(key){
		return SettingUtil_pr_nl.instances[key] || new SettingUtil_pr_nl(key);
	};
	SettingUtil_pr_nl.instances = {};
}